diff -bruN freeswan-1.9.orig/klips/net/ipsec/pfkey_v2_parser.c freeswan-1.9/klips/net/ipsec/pfkey_v2_parser.c
--- freeswan-1.9.orig/klips/net/ipsec/pfkey_v2_parser.c	Mon Feb 26 19:51:01 2001
+++ freeswan-1.9/klips/net/ipsec/pfkey_v2_parser.c	Tue Jun 12 16:51:59 2001
@@ -12,14 +12,14 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: pfkey_v2_parser.c,v 1.68.2.1 2001/02/27 00:51:01 henry Exp $
+ * RCSID $Id: pfkey_v2_parser.c,v 1.82 2001/05/30 08:14:04 rgb Exp $
  */
 
 /*
  *		Template from klips/net/ipsec/ipsec/ipsec_netlink.c.
  */
 
-char pfkey_v2_parser_c_version[] = "$Id: pfkey_v2_parser.c,v 1.68.2.1 2001/02/27 00:51:01 henry Exp $";
+char pfkey_v2_parser_c_version[] = "$Id: pfkey_v2_parser.c,v 1.82 2001/05/30 08:14:04 rgb Exp $";
 
 #include <linux/config.h>
 #include <linux/version.h>
@@ -94,13 +94,15 @@
 	int error = 0;
 	if(*tdb) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_alloc_tdb: tdb struct already allocated\n");
+			    "klips_debug:pfkey_alloc_tdb: "
+			    "tdb struct already allocated\n");
 		SENDERR(EEXIST);
 	}
 
 	if((*tdb = kmalloc(sizeof(**tdb), GFP_ATOMIC) ) == NULL) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_alloc_tdb: memory allocation error\n");
+			    "klips_debug:pfkey_alloc_tdb: "
+			    "memory allocation error\n");
 		SENDERR(ENOMEM);
 	}
 	KLIPS_PRINT(debug_pfkey,
@@ -118,13 +120,15 @@
 	int error = 0;
 	if(*eroute) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_alloc_eroute: eroute struct already allocated\n");
+			    "klips_debug:pfkey_alloc_eroute: "
+			    "eroute struct already allocated\n");
 		SENDERR(EEXIST);
 	}
 
 	if((*eroute = kmalloc(sizeof(**eroute), GFP_ATOMIC) ) == NULL) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_alloc_eroute: memory allocation error\n");
+			    "klips_debug:pfkey_alloc_eroute: "
+			    "memory allocation error\n");
 		SENDERR(ENOMEM);
 	}
 	KLIPS_PRINT(debug_pfkey,
@@ -137,6 +141,9 @@
 		(*eroute)->er_emask.sen_family = AF_ENCAP;
 	(*eroute)->er_eaddr.sen_type = SENT_IP4;
 	(*eroute)->er_emask.sen_type = 255;
+	(*eroute)->er_pid = 0;
+	(*eroute)->er_count = 0;
+	(*eroute)->er_lasttime = jiffies/HZ;
 
  errlab:
 	return(error);
@@ -171,7 +178,8 @@
 		break;
 	default:
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_sa_process: invalid exttype=%d.\n",
+			    "klips_debug:pfkey_sa_process: "
+			    "invalid exttype=%d.\n",
 			    pfkey_ext->sadb_ext_type);
 		SENDERR(EINVAL);
 	}
@@ -201,6 +209,10 @@
 		tdbp->tdb_encalg = pfkey_sa->sadb_sa_encrypt;
 		break;
 #endif /* CONFIG_IPSEC_IPCOMP */
+	case IPPROTO_INT:
+		tdbp->tdb_authalg = AH_NONE;
+		tdbp->tdb_encalg = ESP_NONE;
+		break;
 	case 0:
 		break;
 	default:
@@ -324,7 +336,8 @@
 		break;
 	default:
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug: pfkey_lifetime_process: invalid exttype=%d.\n",
+			    "klips_debug:pfkey_lifetime_process: "
+			    "invalid exttype=%d.\n",
 			    pfkey_ext->sadb_ext_type);
 		SENDERR(EINVAL);
 	}
@@ -349,7 +362,7 @@
 	
 	if(!extr || !extr->tdb) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_address_process:\n"
+			    "klips_debug:pfkey_address_process: "
 			    "extr or extr->tdb is NULL, fatal\n");
 		SENDERR(EINVAL);
 	}
@@ -359,8 +372,10 @@
 		saddr_len = sizeof(struct sockaddr_in);
 		addrtoa(((struct sockaddr_in*)s)->sin_addr, 0, ipaddr_txt, sizeof(ipaddr_txt));
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_address_process: found address family=%d, AF_INET, %s.\n",
-			    s->sa_family, ipaddr_txt);
+			    "klips_debug:pfkey_address_process: "
+			    "found address family=%d, AF_INET, %s.\n",
+			    s->sa_family,
+			    ipaddr_txt);
 		break;
 #if defined(CONFIG_IPV6) || defined(CONFIG_IPV6_MODULE)
 	case AF_INET6:
@@ -369,7 +384,8 @@
 #endif /* defined(CONFIG_IPV6) || defined(CONFIG_IPV6_MODULE) */
 	default:
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_address_process: s->sa_family=%d not supported.\n",
+			    "klips_debug:pfkey_address_process: "
+			    "s->sa_family=%d not supported.\n",
 			    s->sa_family);
 		SENDERR(EPFNOSUPPORT);
 	}
@@ -377,25 +393,29 @@
 	switch(pfkey_address->sadb_address_exttype) {
 	case SADB_EXT_ADDRESS_SRC:
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_address_process: found src address.\n");
+			    "klips_debug:pfkey_address_process: "
+			    "found src address.\n");
 		sap = (unsigned char **)&(extr->tdb->tdb_addr_s);
 		extr->tdb->tdb_addr_s_size = saddr_len;
 		break;
 	case SADB_EXT_ADDRESS_DST:
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_address_process: found dst address.\n");
+			    "klips_debug:pfkey_address_process: "
+			    "found dst address.\n");
 		sap = (unsigned char **)&(extr->tdb->tdb_addr_d);
 		extr->tdb->tdb_addr_d_size = saddr_len;
 		break;
 	case SADB_EXT_ADDRESS_PROXY:
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_address_process: found proxy address.\n");
+			    "klips_debug:pfkey_address_process: "
+			    "found proxy address.\n");
 		sap = (unsigned char **)&(extr->tdb->tdb_addr_p);
 		extr->tdb->tdb_addr_p_size = saddr_len;
 		break;
 	case SADB_X_EXT_ADDRESS_DST2:
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_address_process: found 2nd dst address.\n");
+			    "klips_debug:pfkey_address_process: "
+			    "found 2nd dst address.\n");
 		if(pfkey_alloc_tdb(&(extr->tdb2)) == ENOMEM) {
 			SENDERR(ENOMEM);
 		}
@@ -404,7 +424,8 @@
 		break;
 	case SADB_X_EXT_ADDRESS_SRC_FLOW:
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_address_process: found src flow address.\n");
+			    "klips_debug:pfkey_address_process: "
+			    "found src flow address.\n");
 		if(pfkey_alloc_eroute(&(extr->eroute)) == ENOMEM) {
 			SENDERR(ENOMEM);
 		}
@@ -412,7 +433,8 @@
 		break;
 	case SADB_X_EXT_ADDRESS_DST_FLOW:
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_address_process: found dst flow address.\n");
+			    "klips_debug:pfkey_address_process: "
+			    "found dst flow address.\n");
 		if(pfkey_alloc_eroute(&(extr->eroute)) == ENOMEM) {
 			SENDERR(ENOMEM);
 		}
@@ -420,7 +442,8 @@
 		break;
 	case SADB_X_EXT_ADDRESS_SRC_MASK:
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_address_process: found src mask address.\n");
+			    "klips_debug:pfkey_address_process: "
+			    "found src mask address.\n");
 		if(pfkey_alloc_eroute(&(extr->eroute)) == ENOMEM) {
 			SENDERR(ENOMEM);
 		}
@@ -428,7 +451,8 @@
 		break;
 	case SADB_X_EXT_ADDRESS_DST_MASK:
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_address_process: found dst mask address.\n");
+			    "klips_debug:pfkey_address_process: "
+			    "found dst mask address.\n");
 		if(pfkey_alloc_eroute(&(extr->eroute)) == ENOMEM) {
 			SENDERR(ENOMEM);
 		}
@@ -436,7 +460,8 @@
 		break;
 	default:
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_address_process: unrecognised ext_type=%d.\n",
+			    "klips_debug:pfkey_address_process: "
+			    "unrecognised ext_type=%d.\n",
 			    pfkey_address->sadb_address_exttype);
 		SENDERR(EINVAL);
 	}
@@ -454,7 +479,8 @@
 	default:
 		if(s->sa_family	!= AF_INET) {
 			KLIPS_PRINT(debug_pfkey,
-				    "klips_debug:pfkey_address_process: s->sa_family=%d not supported.\n",
+				    "klips_debug:pfkey_address_process: "
+				    "s->sa_family=%d not supported.\n",
 				    s->sa_family);
 			SENDERR(EPFNOSUPPORT);
 		}
@@ -483,24 +509,26 @@
 	case SADB_EXT_ADDRESS_DST:
 		if(s->sa_family == AF_INET) {
 			tdbp->tdb_said.dst.s_addr = ((struct sockaddr_in*)(tdbp->tdb_addr_d))->sin_addr.s_addr;
+#if 0
 			KLIPS_PRINT(debug_pfkey,
-				    "klips_debug:pfkey_address_process: tdbp->tdb_said.dst.s_addr=%08x,\n"
-				    "klips_debug:                     ((struct sockaddr_in*)(tdbp->tdb_addr_d))->sin_addr.s_addr=%08x,\n",
+				    "klips_debug:pfkey_address_process: "
+				    "tdbp->tdb_said.dst.s_addr=%08x, ((struct sockaddr_in*)(tdbp->tdb_addr_d))->sin_addr.s_addr=%08x,\n",
 				    tdbp->tdb_said.dst.s_addr,
 				    ((struct sockaddr_in*)(tdbp->tdb_addr_d))->sin_addr.s_addr
 				);
+#endif
 			addrtoa(((struct sockaddr_in*)(tdbp->tdb_addr_d))->sin_addr,
 				0,
 				ipaddr_txt,
 				sizeof(ipaddr_txt));
 			KLIPS_PRINT(debug_pfkey,
-				    "klips_debug:pfkey_address_process: tdb_said.dst set to %s.\n",
+				    "klips_debug:pfkey_address_process: "
+				    "tdb_said.dst set to %s.\n",
 				    ipaddr_txt);
 		} else {
 			KLIPS_PRINT(debug_pfkey,
 				    "klips_debug:pfkey_address_process: "
-				    "uh, tdb_said.dst doesn't do address family=%d yet, "
-				    "said will be invalid.\n",
+				    "uh, tdb_said.dst doesn't do address family=%d yet, said will be invalid.\n",
 				    s->sa_family);
 		}
 	default:
@@ -532,33 +560,38 @@
 
         switch(pfkey_key->sadb_key_exttype) {
         case SADB_EXT_KEY_AUTH:
-                extr->tdb->tdb_key_bits_a = pfkey_key->sadb_key_bits;
 		if(!(extr->tdb->tdb_key_a = kmalloc(DIVUP(pfkey_key->sadb_key_bits, 8), GFP_KERNEL))) {
 			KLIPS_PRINT(debug_pfkey,
-				    "klips_debug:pfkey_key_process: memory allocation error.\n");
+				    "klips_debug:pfkey_key_process: "
+				    "memory allocation error.\n");
 			SENDERR(ENOMEM);
 		}
+                extr->tdb->tdb_key_bits_a = pfkey_key->sadb_key_bits;
+                extr->tdb->tdb_key_a_size = DIVUP(pfkey_key->sadb_key_bits, 8);
 		memcpy(extr->tdb->tdb_key_a,
 		       (char*)pfkey_key + sizeof(struct sadb_key),
-		       DIVUP(pfkey_key->sadb_key_bits, 8));
+		       extr->tdb->tdb_key_a_size);
 		break;
 	case SADB_EXT_KEY_ENCRYPT: /* Key(s) */
-		extr->tdb->tdb_key_bits_e = pfkey_key->sadb_key_bits;
 		if(!(extr->tdb->tdb_key_e = kmalloc(DIVUP(pfkey_key->sadb_key_bits, 8), GFP_KERNEL))) {
 			KLIPS_PRINT(debug_pfkey,
-				    "klips_debug:pfkey_key_process: memory allocation error.\n");
+				    "klips_debug:pfkey_key_process: "
+				    "memory allocation error.\n");
 			SENDERR(ENOMEM);
 		}
+		extr->tdb->tdb_key_bits_e = pfkey_key->sadb_key_bits;
+		extr->tdb->tdb_key_e_size = DIVUP(pfkey_key->sadb_key_bits, 8);
 		memcpy(extr->tdb->tdb_key_e,
 		       (char*)pfkey_key + sizeof(struct sadb_key),
-		       DIVUP(pfkey_key->sadb_key_bits, 8));
+		       extr->tdb->tdb_key_e_size);
 		break;
 	default:
 		SENDERR(EINVAL);
  	}
 
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_key_process: success.\n");
+		    "klips_debug:pfkey_key_process: "
+		    "success.\n");
 errlab:
 	return error;
 }
@@ -629,7 +662,8 @@
         int error = 0;
 	
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug: pfkey_sens_process: Sorry, I can't process exttype=%d yet.\n",
+		    "klips_debug:pfkey_sens_process: "
+		    "Sorry, I can't process exttype=%d yet.\n",
 		    pfkey_ext->sadb_ext_type);
         SENDERR(EINVAL); /* don't process these yet */
  errlab:
@@ -642,7 +676,8 @@
         int error = 0;
 	
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug: pfkey_prop_process: Sorry, I can't process exttype=%d yet.\n",
+		    "klips_debug:pfkey_prop_process: "
+		    "Sorry, I can't process exttype=%d yet.\n",
 		    pfkey_ext->sadb_ext_type);
 	SENDERR(EINVAL); /* don't process these yet */
 	
@@ -656,7 +691,8 @@
         int error = 0;
 
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug: pfkey_supported_process: Sorry, I can't process exttype=%d yet.\n",
+		    "klips_debug:pfkey_supported_process: "
+		    "Sorry, I can't process exttype=%d yet.\n",
 		    pfkey_ext->sadb_ext_type);
 	SENDERR(EINVAL); /* don't process these yet */
 
@@ -670,7 +706,7 @@
         int error = 0;
 
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug: pfkey_spirange_process: .\n");
+		    "klips_debug:pfkey_spirange_process: .\n");
 /* errlab: */
 	return error;
 }
@@ -681,7 +717,8 @@
 	int error = 0;
 
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug: pfkey_x_kmprivate_process: Sorry, I can't process exttype=%d yet.\n",
+		    "klips_debug:pfkey_x_kmprivate_process: "
+		    "Sorry, I can't process exttype=%d yet.\n",
 		    pfkey_ext->sadb_ext_type);
 	SENDERR(EINVAL); /* don't process these yet */
 
@@ -696,11 +733,11 @@
 	struct sadb_x_satype *pfkey_x_satype = (struct sadb_x_satype *)pfkey_ext;
 
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug: pfkey_x_satype_process: .\n");
+		    "klips_debug:pfkey_x_satype_process: .\n");
 
 	if(!extr || !extr->tdb) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug: pfkey_x_satype_process: "
+			    "klips_debug:pfkey_x_satype_process: "
 			    "extr or extr->tdb is NULL, fatal\n");
 		SENDERR(EINVAL);
 	}
@@ -710,10 +747,17 @@
 	}
 	if(!(extr->tdb2->tdb_said.proto = satype2proto(pfkey_x_satype->sadb_x_satype_satype))) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug: pfkey_x_satype_process: proto lookup from satype=%d failed.\n",
+			    "klips_debug:pfkey_x_satype_process: "
+			    "proto lookup from satype=%d failed.\n",
 			    pfkey_x_satype->sadb_x_satype_satype);
 		SENDERR(EINVAL);
 	}
+	KLIPS_PRINT(debug_pfkey,
+		    "klips_debug:pfkey_x_satype_process: "
+		    "protocol==%d decoded from satype==%d(%s).\n",
+		    extr->tdb2->tdb_said.proto,
+		    pfkey_x_satype->sadb_x_satype_satype,
+		    satype2name(pfkey_x_satype->sadb_x_satype_satype));
 
 errlab:
 	return error;
@@ -726,7 +770,8 @@
 	struct sadb_x_debug *pfkey_x_debug = (struct sadb_x_debug *)pfkey_ext;
 
 	if(!pfkey_x_debug) {
-		printk("klips_debug:pfkey_x_debug_process: null pointer passed in\n");
+		printk("klips_debug:pfkey_x_debug_process: "
+		       "null pointer passed in\n");
 		SENDERR(EINVAL);
 	}
 
@@ -752,10 +797,8 @@
 			sysctl_ipsec_debug_ipcomp  |= pfkey_x_debug->sadb_x_debug_ipcomp;
 #endif /* CONFIG_IPSEC_IPCOMP */
 			sysctl_ipsec_debug_verbose |= pfkey_x_debug->sadb_x_debug_verbose;
-			if(debug_netlink)
 				printk(KERN_INFO "klips_debug:pfkey_x_debug_process: set\n");
 		} else {
-			if(debug_netlink)
 				printk(KERN_INFO "klips_debug:pfkey_x_debug_process: unset\n");
 			debug_tunnel  &= pfkey_x_debug->sadb_x_debug_tunnel;
 			debug_netlink &= pfkey_x_debug->sadb_x_debug_netlink;
@@ -773,7 +816,8 @@
 			sysctl_ipsec_debug_verbose &= pfkey_x_debug->sadb_x_debug_verbose;
 		}
 #else /* CONFIG_IPSEC_DEBUG */
-		printk("klips_debug:pfkey_x_debug_process: debugging not enabled\n");
+		printk("klips_debug:pfkey_x_debug_process: "
+		       "debugging not enabled\n");
 		SENDERR(EINVAL);
 #endif /* CONFIG_IPSEC_DEBUG */
 	
@@ -788,6 +832,7 @@
         int i;
         int error = 0;
         char sa[SATOA_BUF];
+	size_t sa_len;
 	char ipaddr_txt[ADDRTOA_BUF];
 	char ipaddr2_txt[ADDRTOA_BUF];
 	unsigned char kb[AHMD596_BLKLEN];
@@ -799,13 +844,16 @@
 		SENDERR(EINVAL);
 	}
 
-	satoa(tdbp->tdb_said, 0, sa, SATOA_BUF);
+	sa_len = satoa(tdbp->tdb_said, 0, sa, SATOA_BUF);
 
         KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_tdb_init: (pfkey defined) called for SA:%s\n", sa);
+		    "klips_debug:pfkey_tdb_init: "
+		    "(pfkey defined) called for SA:%s\n",
+		    sa_len ? sa : " (error)");
 
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_tdb_init: calling init routine of %s%s%s\n",
+		    "klips_debug:pfkey_tdb_init: "
+		    "calling init routine of %s%s%s\n",
 		    TDB_XFORM_NAME(tdbp));
 	
 	switch(tdbp->tdb_said.proto) {
@@ -832,20 +880,22 @@
 # ifdef CONFIG_IPSEC_AUTH_HMAC_MD5
 		case AH_MD5: {
 			unsigned char *akp;
+			unsigned int aks;
 			MD5_CTX *ictx;
 			MD5_CTX *octx;
 			
 			if(tdbp->tdb_key_bits_a != (AHMD596_KLEN * 8)) {
 				KLIPS_PRINT(debug_pfkey,
-					    "klips_debug:pfkey_tdb_init: incorrect key size: %d bits"
-					    "-- must be %d bits\n"/*octets (bytes)\n"*/,
+					    "klips_debug:pfkey_tdb_init: "
+					    "incorrect key size: %d bits -- must be %d bits\n"/*octets (bytes)\n"*/,
 					    tdbp->tdb_key_bits_a, AHMD596_KLEN * 8);
 				SENDERR(EINVAL);
 			}
 			
 #  if 0 /* we don't really want to print these unless there are really big problems */
 			KLIPS_PRINT(debug_pfkey && sysctl_ipsec_debug_verbose,
-					    "klips_debug:pfkey_tdb_init: hmac md5-96 key is 0x%08lx %08lx %08lx %08lx\n",
+				    "klips_debug:pfkey_tdb_init: "
+				    "hmac md5-96 key is 0x%08lx %08lx %08lx %08lx\n",
 				    ntohl(*(((__u32 *)tdbp->tdb_key_a)+0)),
 				    ntohl(*(((__u32 *)tdbp->tdb_key_a)+1)),
 				    ntohl(*(((__u32 *)tdbp->tdb_key_a)+2)),
@@ -856,12 +906,14 @@
 			
 			/* save the pointer to the key material */
 			akp = tdbp->tdb_key_a;
+			aks = tdbp->tdb_key_a_size;
 			
 			if((tdbp->tdb_key_a = (caddr_t)
-			    kmalloc((tdbp->tdb_key_a_size = sizeof(struct md5_ctx)),
-				    GFP_ATOMIC)) == NULL) {
+			    kmalloc(sizeof(struct md5_ctx), GFP_ATOMIC)) == NULL) {
+				tdbp->tdb_key_a = akp;
 				SENDERR(ENOMEM);
 			}
+			tdbp->tdb_key_a_size = sizeof(struct md5_ctx);
 
 			for (i = 0; i < DIVUP(tdbp->tdb_key_bits_a, 8); i++) {
 				kb[i] = akp[i] ^ HMAC_IPAD;
@@ -884,8 +936,8 @@
 			
 #  if 0 /* we don't really want to print these unless there are really big problems */
 			KLIPS_PRINT(debug_pfkey && sysctl_ipsec_debug_verbose,
-				    "klips_debug:pfkey_tdb_init: MD5 ictx=0x%08x %08x %08x %08x"
-				    " octx=0x%08x %08x %08x %08x\n",
+				    "klips_debug:pfkey_tdb_init: "
+				    "MD5 ictx=0x%08x %08x %08x %08x octx=0x%08x %08x %08x %08x\n",
 				    ((__u32*)ictx)[0],
 				    ((__u32*)ictx)[1],
 				    ((__u32*)ictx)[2],
@@ -897,28 +949,30 @@
 #  endif
 			
 				/* zero key buffer -- paranoid */
-			memset(akp, 0, DIVUP(tdbp->tdb_key_bits_a, BITS_PER_OCTET));
+			memset(akp, 0, aks);
+			kfree(akp);
 		}
 		break;
 # endif /* CONFIG_IPSEC_AUTH_HMAC_MD5 */
 # ifdef CONFIG_IPSEC_AUTH_HMAC_SHA1
 		case AH_SHA: {
-			
 			unsigned char *akp;
+			unsigned int aks;
 			SHA1_CTX *ictx;
 			SHA1_CTX *octx;
 			
 			if(tdbp->tdb_key_bits_a != (AHSHA196_KLEN * 8)) {
 				KLIPS_PRINT(debug_pfkey,
-					    "klips_debug:pfkey_tdb_init: incorrect key size: %d bits"
-					    "-- must be %d bits\n"/*octets (bytes)\n"*/,
+					    "klips_debug:pfkey_tdb_init: "
+					    "incorrect key size: %d bits -- must be %d bits\n"/*octets (bytes)\n"*/,
 					    tdbp->tdb_key_bits_a, AHSHA196_KLEN * 8);
 				SENDERR(EINVAL);
 			}
 			
 #  if 0 /* we don't really want to print these unless there are really big problems */
 			KLIPS_PRINT(debug_pfkey && sysctl_ipsec_debug_verbose,
-				    "klips_debug:pfkey_tdb_init: hmac sha1-96 key is 0x%08lx %08lx %08lx %08lx\n",
+				    "klips_debug:pfkey_tdb_init: "
+				    "hmac sha1-96 key is 0x%08lx %08lx %08lx %08lx\n",
 				    ntohl(*(((__u32 *)tdbp->tdb_key_a)+0)),
 				    ntohl(*(((__u32 *)tdbp->tdb_key_a)+1)),
 				    ntohl(*(((__u32 *)tdbp->tdb_key_a)+2)),
@@ -929,12 +983,14 @@
 			
 			/* save the pointer to the key material */
 			akp = tdbp->tdb_key_a;
+			aks = tdbp->tdb_key_a_size;
 			
 			if((tdbp->tdb_key_a = (caddr_t)
-			    kmalloc((tdbp->tdb_key_a_size = sizeof(struct sha1_ctx)),
-				    GFP_ATOMIC)) == NULL) {
+			    kmalloc(sizeof(struct sha1_ctx), GFP_ATOMIC)) == NULL) {
+				tdbp->tdb_key_a = akp;
 				SENDERR(ENOMEM);
 			}
+			tdbp->tdb_key_a_size = sizeof(struct sha1_ctx);
 			
 			for (i = 0; i < DIVUP(tdbp->tdb_key_bits_a, 8); i++) {
 				kb[i] = akp[i] ^ HMAC_IPAD;
@@ -957,8 +1013,8 @@
 			
 #  if 0 /* we don't really want to print these unless there are really big problems */
 			KLIPS_PRINT(debug_pfkey && sysctl_ipsec_debug_verbose,
-				    "klips_debug:pfkey_tdb_init: SHA1 ictx=0x%08x %08x %08x %08x"
-				    " octx=0x%08x %08x %08x %08x\n", 
+				    "klips_debug:pfkey_tdb_init: "
+				    "SHA1 ictx=0x%08x %08x %08x %08x octx=0x%08x %08x %08x %08x\n", 
 				    ((__u32*)ictx)[0],
 				    ((__u32*)ictx)[1],
 				    ((__u32*)ictx)[2],
@@ -969,7 +1025,8 @@
 				    ((__u32*)octx)[3] );
 #  endif			
 				/* zero key buffer -- paranoid */
-			memset(akp, 0, DIVUP(tdbp->tdb_key_bits_a, BITS_PER_OCTET));
+			memset(akp, 0, aks);
+			kfree(akp);
 		}
 		break;
 # endif /* CONFIG_IPSEC_AUTH_HMAC_SHA1 */
@@ -985,12 +1042,16 @@
 #ifdef CONFIG_IPSEC_ESP
 	case IPPROTO_ESP: {
 		unsigned char *akp, *ekp;
+		unsigned int aks, eks;
 		
 		switch(tdbp->tdb_encalg) {
-# ifdef CONFIG_IPSEC_ENC_3DES
+#ifdef CONFIG_IPSEC_ENC_DES
+		case ESP_DES:
+#endif /* CONFIG_IPSEC_ENC_DES */
+#ifdef CONFIG_IPSEC_ENC_3DES
 		case ESP_3DES:
-# endif /* CONFIG_IPSEC_ENC_3DES */
-# if defined(CONFIG_IPSEC_ENC_3DES)
+#endif /* CONFIG_IPSEC_ENC_3DES */
+#if defined(CONFIG_IPSEC_ENC_DES) || defined(CONFIG_IPSEC_ENC_3DES)
 			if((tdbp->tdb_iv = (caddr_t)
 			    kmalloc((tdbp->tdb_iv_size = EMT_ESPDES_IV_SZ), GFP_ATOMIC)) == NULL) {
 				SENDERR(ENOMEM);
@@ -998,11 +1059,8 @@
 			get_random_bytes((void *)tdbp->tdb_iv, EMT_ESPDES_IV_SZ);
 			tdbp->tdb_iv_bits = tdbp->tdb_iv_size * 8;
 			break;
-# endif /* defined(CONFIG_IPSEC_ENC_3DES) */
+#endif /* defined(CONFIG_IPSEC_ENC_DES) || defined(CONFIG_IPSEC_ENC_3DES) */
 		case ESP_NONE:
-# ifdef CONFIG_IPSEC_ENC_NULL
-		case ESP_NULL:
-# endif /* CONFIG_IPSEC_ENC_NULL */
 			break;
 		default:
 			KLIPS_PRINT(debug_pfkey,
@@ -1013,55 +1071,103 @@
 		}
 		
 		switch(tdbp->tdb_encalg) {
-# ifdef CONFIG_IPSEC_ENC_3DES
+#ifdef CONFIG_IPSEC_ENC_DES
+		case ESP_DES:
+			if(tdbp->tdb_key_bits_e != (EMT_ESPDES_KEY_SZ * 8)) {
+				KLIPS_PRINT(debug_pfkey,
+					    "klips_debug:pfkey_tdb_init: "
+					    "incorrect encryption key size: %d bits -- must be %d bits\n"/*octets (bytes)\n"*/,
+					    tdbp->tdb_key_bits_e, EMT_ESPDES_KEY_SZ * 8);
+				SENDERR(EINVAL);
+			}
+			
+			/* save encryption key pointer */
+			ekp = tdbp->tdb_key_e;
+			eks = tdbp->tdb_key_e_size;
+			
+			if((tdbp->tdb_key_e = (caddr_t)
+			    kmalloc(sizeof(struct des_eks), GFP_ATOMIC)) == NULL) {
+				tdbp->tdb_key_e = ekp;
+				SENDERR(ENOMEM);
+			}
+			tdbp->tdb_key_e_size = sizeof(struct des_eks);
+
+#if 0 /* we don't really want to print these unless there are really big problems */
+                       KLIPS_PRINT(debug_pfkey,
+                                   "klips_debug:pfkey_tdb_init: des key 1 is 0x%08lx%08lx\n",
+                                   ntohl(*((__u32 *)ed->eme_key)),
+                                   ntohl(*((__u32 *)ed->eme_key + 1)));
+#endif
+			error = des_set_key((caddr_t)ekp, 
+					    (caddr_t)(tdbp->tdb_key_e));
+			if (error == -1)
+					printk("klips_debug:pfkey_tdb_init: "
+					       "parity error in des key\n");
+				else if (error == -2)
+					printk("klips_debug:pfkey_tdb_init: "
+					       "illegal weak des key\n");
+				if (error) {
+					memset(ekp, 0, eks);
+					kfree(ekp);
+					SENDERR(EINVAL);
+				}
+
+			/* paranoid */
+			memset(ekp, 0, eks);
+			kfree(ekp);
+			break;
+#endif /* CONFIG_IPSEC_ENC_DES */
+#ifdef CONFIG_IPSEC_ENC_3DES
 		case ESP_3DES:
 			if(tdbp->tdb_key_bits_e != (EMT_ESP3DES_KEY_SZ * 8)) {
 				KLIPS_PRINT(debug_pfkey,
-					    "klips_debug:pfkey_tdb_init: incorrect encryption"
-					    "key size: %d bits -- must be %d bits\n"/*octets (bytes)\n"*/,
+					    "klips_debug:pfkey_tdb_init: "
+					    "incorrect encryption key size: %d bits -- must be %d bits\n"/*octets (bytes)\n"*/,
 					    tdbp->tdb_key_bits_e, EMT_ESP3DES_KEY_SZ * 8);
 				SENDERR(EINVAL);
 			}
 			
 			/* save encryption key pointer */
 			ekp = tdbp->tdb_key_e;
+			eks = tdbp->tdb_key_e_size;
 			
 			if((tdbp->tdb_key_e = (caddr_t)
-			    kmalloc((tdbp->tdb_key_e_size = 3 * sizeof(struct des_eks)),
-				    GFP_ATOMIC)) == NULL) {
+			    kmalloc(3 * sizeof(struct des_eks), GFP_ATOMIC)) == NULL) {
+				tdbp->tdb_key_e = ekp;
 				SENDERR(ENOMEM);
 			}
+			tdbp->tdb_key_e_size = 3 * sizeof(struct des_eks);
 			
 			for(i = 0; i < 3; i++) {
-#  if 0 /* we don't really want to print these unless there are really big problems */
+#if 0 /* we don't really want to print these unless there are really big problems */
 				KLIPS_PRINT(debug_pfkey && sysctl_ipsec_debug_verbose,
-					    "klips_debug:pfkey_tdb_init: 3des key %d/3 is 0x%08lx%08lx\n",
+					    "klips_debug:pfkey_tdb_init: "
+					    "3des key %d/3 is 0x%08lx%08lx\n",
 					    i + 1,
-					    ntohl(*((__u32 *)tdbp->tdb_key_e + i * 2)),
-					    ntohl(*((__u32 *)tdbp->tdb_key_e + i * 2 + 1)));
-#  endif
+					    ntohl(*((__u32 *)ekp + i * 2)),
+					    ntohl(*((__u32 *)ekp + i * 2 + 1)));
+#endif
 				error = des_set_key((caddr_t)ekp + EMT_ESPDES_KEY_SZ * i,
 						    (caddr_t)&((struct des_eks*)(tdbp->tdb_key_e))[i]);
 				if (error == -1)
-					printk("klips_debug:pfkey_tdb_init: parity error in des key %d/3\n", i + 1);
+					printk("klips_debug:pfkey_tdb_init: "
+					       "parity error in des key %d/3\n",
+					       i + 1);
 				else if (error == -2)
-					printk("klips_debug:pfkey_tdb_init: illegal weak des key %d/3\n", i + 1);
+					printk("klips_debug:pfkey_tdb_init: "
+					       "illegal weak des key %d/3\n", i + 1);
 				if (error) {
-					memset(tdbp->tdb_key_e, 0, 3 * sizeof(struct des_eks));
-					kfree(tdbp->tdb_key_e);
-					memset(ekp, 0, DIVUP(tdbp->tdb_key_bits_e, BITS_PER_OCTET));
+					memset(ekp, 0, eks);
+					kfree(ekp);
 					SENDERR(EINVAL);
 				}
 			}
 
 			/* paranoid */
-			memset(ekp, 0, DIVUP(tdbp->tdb_key_bits_e, BITS_PER_OCTET));
-			
+			memset(ekp, 0, eks);
+			kfree(ekp);
 			break;
-# endif /* CONFIG_IPSEC_ENC_3DES */
-# ifdef CONFIG_IPSEC_ENC_NULL
-		case ESP_NULL:
-# endif /* CONFIG_IPSEC_ENC_NULL */
+#endif /* CONFIG_IPSEC_ENC_3DES */
 		case ESP_NONE:
 			break;
 		default:
@@ -1073,37 +1179,41 @@
 		}
 		
 		switch(tdbp->tdb_authalg) {
-# ifdef CONFIG_IPSEC_AUTH_HMAC_MD5
+#ifdef CONFIG_IPSEC_AUTH_HMAC_MD5
 		case AH_MD5: {
 			MD5_CTX *ictx;
 			MD5_CTX *octx;
 
 			if(tdbp->tdb_key_bits_a != (AHMD596_KLEN * 8)) {
 				KLIPS_PRINT(debug_pfkey,
-					    "klips_debug:pfkey_tdb_init: incorrect authorisation"
-					    " key size: %d bits -- must be %d bits\n"/*octets (bytes)\n"*/,
-					    tdbp->tdb_key_bits_a, AHMD596_KLEN * 8);
+					    "klips_debug:pfkey_tdb_init: "
+					    "incorrect authorisation key size: %d bits -- must be %d bits\n"/*octets (bytes)\n"*/,
+					    tdbp->tdb_key_bits_a,
+					    AHMD596_KLEN * 8);
 				SENDERR(EINVAL);
 			}
 			
-#  if 0 /* we don't really want to print these unless there are really big problems */
+#if 0 /* we don't really want to print these unless there are really big problems */
 			KLIPS_PRINT(debug_pfkey && sysctl_ipsec_debug_verbose,
-				    "klips_debug:pfkey_tdb_init: hmac md5-96 key is 0x%08lx %08lx %08lx %08lx\n",
+				    "klips_debug:pfkey_tdb_init: "
+				    "hmac md5-96 key is 0x%08lx %08lx %08lx %08lx\n",
 				    ntohl(*(((__u32 *)(tdbp->tdb_key_a))+0)),
 				    ntohl(*(((__u32 *)(tdbp->tdb_key_a))+1)),
 				    ntohl(*(((__u32 *)(tdbp->tdb_key_a))+2)),
 				    ntohl(*(((__u32 *)(tdbp->tdb_key_a))+3)));
-#  endif
+#endif
 			tdbp->tdb_auth_bits = AHMD596_ALEN * 8;
 			
 			/* save the pointer to the key material */
 			akp = tdbp->tdb_key_a;
+			aks = tdbp->tdb_key_a_size;
 			
 			if((tdbp->tdb_key_a = (caddr_t)
-			    kmalloc((tdbp->tdb_key_a_size = sizeof(struct md5_ctx)),
-				    GFP_ATOMIC)) == NULL) {
+			    kmalloc(sizeof(struct md5_ctx), GFP_ATOMIC)) == NULL) {
+				tdbp->tdb_key_a = akp;
 				SENDERR(ENOMEM);
 			}
+			tdbp->tdb_key_a_size = sizeof(struct md5_ctx);
 			
 			for (i = 0; i < DIVUP(tdbp->tdb_key_bits_a, 8); i++) {
 				kb[i] = akp[i] ^ HMAC_IPAD;
@@ -1126,8 +1236,8 @@
 			
 #  if 0 /* we don't really want to print these unless there are really big problems */
 			KLIPS_PRINT(debug_pfkey && sysctl_ipsec_debug_verbose,
-				    "klips_debug:pfkey_tdb_init: MD5 ictx=0x%08x %08x %08x %08x"
-				    " octx=0x%08x %08x %08x %08x\n",
+				    "klips_debug:pfkey_tdb_init: "
+				    "MD5 ictx=0x%08x %08x %08x %08x octx=0x%08x %08x %08x %08x\n",
 				    ((__u32*)ictx)[0],
 				    ((__u32*)ictx)[1],
 				    ((__u32*)ictx)[2],
@@ -1138,7 +1248,8 @@
 				    ((__u32*)octx)[3] );
 #  endif
 			/* paranoid */
-			memset(akp, 0, DIVUP(tdbp->tdb_key_bits_a, BITS_PER_OCTET));
+			memset(akp, 0, aks);
+			kfree(akp);
 			break;
 		}
 # endif /* CONFIG_IPSEC_AUTH_HMAC_MD5 */
@@ -1149,15 +1260,17 @@
 
 			if(tdbp->tdb_key_bits_a != (AHSHA196_KLEN * 8)) {
 				KLIPS_PRINT(debug_pfkey,
-					    "klips_debug:pfkey_tdb_init: incorrect authorisation"
-					    " key size: %d bits -- must be %d bits\n"/*octets (bytes)\n"*/,
-					    tdbp->tdb_key_bits_a, AHSHA196_KLEN * 8);
+					    "klips_debug:pfkey_tdb_init: "
+					    "incorrect authorisation key size: %d bits -- must be %d bits\n"/*octets (bytes)\n"*/,
+					    tdbp->tdb_key_bits_a,
+					    AHSHA196_KLEN * 8);
 				SENDERR(EINVAL);
 			}
 			
 #  if 0 /* we don't really want to print these unless there are really big problems */
 			KLIPS_PRINT(debug_pfkey && sysctl_ipsec_debug_verbose,
-				    "klips_debug:pfkey_tdb_init: hmac sha1-96 key is 0x%08lx %08lx %08lx %08lx\n",
+				    "klips_debug:pfkey_tdb_init: "
+				    "hmac sha1-96 key is 0x%08lx %08lx %08lx %08lx\n",
 				    ntohl(*(((__u32 *)tdbp->tdb_key_a)+0)),
 				    ntohl(*(((__u32 *)tdbp->tdb_key_a)+1)),
 				    ntohl(*(((__u32 *)tdbp->tdb_key_a)+2)),
@@ -1167,12 +1280,14 @@
 			
 			/* save the pointer to the key material */
 			akp = tdbp->tdb_key_a;
+			aks = tdbp->tdb_key_a_size;
 
 			if((tdbp->tdb_key_a = (caddr_t)
-			    kmalloc((tdbp->tdb_key_a_size = sizeof(struct sha1_ctx)),
-				    GFP_ATOMIC)) == NULL) {
+			    kmalloc(sizeof(struct sha1_ctx), GFP_ATOMIC)) == NULL) {
+				tdbp->tdb_key_a = akp;
 				SENDERR(ENOMEM);
 			}
+			tdbp->tdb_key_a_size = sizeof(struct sha1_ctx);
 			
 			for (i = 0; i < DIVUP(tdbp->tdb_key_bits_a, 8); i++) {
 				kb[i] = akp[i] ^ HMAC_IPAD;
@@ -1195,8 +1310,8 @@
 			
 #  if 0 /* we don't really want to print these unless there are really big problems */
 			KLIPS_PRINT(debug_pfkey && sysctl_ipsec_debug_verbose,
-				    "klips_debug:pfkey_tdb_init: SHA1 ictx=0x%08x %08x %08x %08x"
-				    " octx=0x%08x %08x %08x %08x\n",
+				    "klips_debug:pfkey_tdb_init: "
+				    "SHA1 ictx=0x%08x %08x %08x %08x octx=0x%08x %08x %08x %08x\n",
 				    ((__u32*)ictx)[0],
 				    ((__u32*)ictx)[1],
 				    ((__u32*)ictx)[2],
@@ -1206,7 +1321,8 @@
 				    ((__u32*)octx)[2],
 				    ((__u32*)octx)[3] );
 #  endif
-			memset(akp, 0, DIVUP(tdbp->tdb_key_bits_a, BITS_PER_OCTET));
+			memset(akp, 0, aks);
+			kfree(akp);
 			break;
 		}
 # endif /* CONFIG_IPSEC_AUTH_HMAC_SHA1 */
@@ -1246,14 +1362,17 @@
 int
 pfkey_safe_build(int error, struct sadb_ext *extensions[SADB_MAX+1])
 {
-	KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_safe_build: error=%d\n", error);
+	KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_safe_build: "
+		    "error=%d\n",
+		    error);
 	if (!error) {
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_safe_build:"
 			    "success.\n");
 		return 1;
 	} else {
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_safe_build:"
-			    "caught error %d\n", error);
+			    "caught error %d\n",
+			    error);
 		pfkey_extensions_free(extensions);
 		return 0;
 	}
@@ -1268,6 +1387,7 @@
 	int found_avail = 0;
 	struct tdb *tdbq;
 	char sa[SATOA_BUF];
+	size_t sa_len;
 	struct sadb_ext *extensions_reply[SADB_EXT_MAX+1];
 	struct sadb_msg *pfkey_reply = NULL;
 	struct socket_list *pfkey_socketsp;
@@ -1280,7 +1400,8 @@
 
 	if(!extr || !extr->tdb) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_getspi_parse: error, extr or extr->tdb pointer NULL\n");
+			    "klips_debug:pfkey_getspi_parse: "
+			    "error, extr or extr->tdb pointer NULL\n");
 		SENDERR(EINVAL);
 	}
 
@@ -1292,10 +1413,11 @@
 	if(maxspi == minspi) {
 		extr->tdb->tdb_said.spi = maxspi;
 		if((tdbq = gettdb(&(extr->tdb->tdb_said)))) {
-			satoa(extr->tdb->tdb_said, 0, sa, SATOA_BUF);
+			sa_len = satoa(extr->tdb->tdb_said, 0, sa, SATOA_BUF);
 			KLIPS_PRINT(debug_pfkey,
-				    "klips_debug: pfkey_getspi_parse: EMT_GETSPI found an old Tunnel Descriptor Block\n"
-				    "klips_debug:                for SA: %s, delete it first.\n", sa);
+				    "klips_debug:pfkey_getspi_parse: "
+				    "EMT_GETSPI found an old Tunnel Descriptor Block for SA: %s, delete it first.\n",
+				    sa_len ? sa : " (error)");
 			SENDERR(EEXIST);
 		} else {
 			found_avail = 1;
